/*FILE : root_find_test.c

Programer: Sunethra Ramanan suna@physics.iitm.ac.in

Version: Original

Date: 13 Feb 2012

Revision-History:

Comments:
13 Feb 2012: This code tests the various root finding routines for functions that are defined and passed.
*/

#include <stdio.h>
#include <stdlib.h>
#include <math.h>

/************************** Function Prototype ******************************/
double 
my_func(double x, void *params_ptr);

double my_func_der1(double x, void *params_ptr);

double 
bisection(int max_iter, double eps, double delta, double a, double b, double (*func)(double, void *), void *params_ptr);

/******************************************************************************/


int
main(void)
{
	int N_iter;									/*max. no of iteration allowed*/
	
	double a, b;								/*values of x*/
	double ans;									/*stores the answer*/
	double eps, delta;					/*tolerances for the bisection routines*/
	double R;										/*parameter of the function*/
	
	void *params_ptr;						/*pointer used to pass parameter to the function whose roots we need to find. Here we set equal to NULL as we are not passing anything for now*/
	
	/*intialization*/
	N_iter = 1000;
	
	eps = 1e-14;
	delta = 1e-14;
	
	a = 0.1;
	b = 5.;
	
	R = 13.;
	
	params_ptr = &R;
	
	printf("\n\nvalue of R:%f \n", R);
	
	/*calling bisection routine*/
	ans = bisection(N_iter, eps, delta, a, b, &my_func, params_ptr);
	
	printf("the root1 is:%f and the value of f(s):%e \n", ans, my_func(ans, params_ptr));
	
	return(0);
}

/*************************** defining my_func ********************************/
double 
my_func(double x, void *params_ptr)
{
	double ans;					/*result*/
	double R = *(double *)params_ptr;						/*value of a parameter*/
	
	params_ptr = NULL;	/*intialization of ptr*/
		
	ans = x*x - R;			/*value of func*/
	
	return(ans);
}

/****************************************************************************/
/****************************************************************************/
